from rdflib import Graph, BNode
from rdflib.namespace import RDFS
from rdflib import ConjunctiveGraph, URIRef, RDFS, RDF, Namespace

#from subprocess import call

#call("./../../Ontologies/s-get http://155.207.131.19:3030/Mokos_18_1_7_47/data default >> ../../Ontologies/data.ttl", shell=True)

#Ontology_file = "../../Ontologies/Mokos_18_1_7_47.ttl"
Ontology_file = "../../Ontologies/Autonomy_v1.ttl"

subClass_instances = "../../Ontologies/instances_subclass.txt"

#HERE
list_of_DSO = ["http://delab.csd.auth.gr/ontologies/2018/SAO#","http://delab.csd.auth.gr/ontologies/2018/DSO#", "http://delab.csd.auth.gr/ontologies/2018/DSO-Automotive#", "http://delab.csd.auth.gr/ontologies/2018/DSO-Automotive-AVP#", "http://delab.csd.auth.gr/ontologies/2018/DSO-Automotive-AVP-instances#"]
#list_of_RMO = ["RMO", "RMO-instances", "DSO-AOCS-instances", "<http://delab.csd.auth.gr/ontologies/2018/RDO-instances"]
#list_of_RMO = ["RMO", "RMO-instances", "DSO-Automotive-AVP-instances", "<http://delab.csd.auth.gr/ontologies/2018/DSO-Automotive-AVP-instances"]
DSO = ["http://delab.csd.auth.gr/ontologies/2018/DSO#"]

Dictionary_Data = {}
Dictionary_Data_list = []

g = Graph()
g.load(Ontology_file, format="turtle")

def find_subclass_domain_range():
    file2 = open(r"../../Ontologies/instances.txt","w+") 

    for subj, obj in g.subject_objects(predicate=RDFS.subClassOf):
        subClass = subj + "$"+ obj + "\n"
        file2.write(subClass)
    for subj, obj in g.subject_objects(predicate=RDFS.domain):
        subClass = subj + "$"+ obj + "\n"
        file2.write(subClass)
    for subj, obj in g.subject_objects(predicate=RDFS.range):
        subClass = subj + "$"+ obj + "\n"
        file2.write(subClass)


def findsubclass():
    file2 = open(subClass_instances, "w+") 

    for subj, obj in g.subject_objects(predicate=RDFS.subClassOf):
        subClass = subj + "$"+ obj + "\n"
        file2.write(subClass)


def get_i_instances(keyword):
    out_list = []
    per = URIRef("http://delab.csd.auth.gr/ontologies/2018/"+keyword)
    for s, p, o in g.triples((None, RDF.type, per)):
        split = s.split("#")
        out_list.append(split[len(split) - 1])
    return tuple((str(n), str(n)) for n in (out_list))


'''Get Verbs - return tuple'''
def get_verb_instances(keyword):
    get_file_and_instances(keyword)
    keywordspl = keyword.split("#")
    in_list = []
    out_list = []
    with open('../../Ontologies/instances.txt') as f:
        for data in f:
            if (data.strip()).endswith(keyword):
                spliter_1 = data.split('$')
                spliter_2 = spliter_1[0].split("#")
                in_list.append(spliter_2[len(spliter_2) - 1])
    for extra in in_list:
        per = URIRef("http://delab.csd.auth.gr/ontologies/2018/LO#" +extra)
        for s, p, o in g.triples((None, RDF.type, per)):
            spl = s.split("#")
            out_list.append(str(spl[1]))
    return tuple((str(n), str(n)) for n in (out_list))

'''Get Verbs - return tuple'''
def get_verb_file_and_instances(keyword):
    get_file_and_instances(keyword)
    keywordspl = keyword.split("#")
    in_list = []
    out_list = []
    with open('../../Ontologies/instances.txt') as f:
        for data in f:
            if (data.strip()).endswith(keyword):
                spliter_1 = data.split('$')
                spliter_2 = spliter_1[0].split("#")
                in_list.append(spliter_2[len(spliter_2) - 1])
    for extra in in_list:
        per = URIRef("http://delab.csd.auth.gr/ontologies/2018/LO#" +extra)
        for s, p, o in g.triples((None, RDF.type, per)):
            spl = s.split("#")
            out_list.append(extra + " : " + str(spl[1]))
    return tuple((str(n), str(n)) for n in (out_list))


'''Get Instaces - return tuple'''
def get_instances(keyword):
    get_file_and_instances(keyword)
    keywordspl = keyword.split("#")
    in_list = [keywordspl[len(keywordspl)-1]]
    out_list = []
    with open('../../Ontologies/instances.txt') as f:
        for data in f:
            if (data.strip()).endswith(keyword):
                spliter_1 = data.split('$')
                spliter_2 = spliter_1[0].split("#")
                in_list.append(spliter_2[len(spliter_2) - 1])
    for extra in in_list:
        for uri in list_of_DSO:
            per = URIRef(uri +extra)
            for s, p, o in g.triples((None, RDFS.subClassOf, per)): #subClassOf
                spl = s.split("#")
                in_list.append(spl[len(spl) - 1])
    for extra in in_list:
        for uri in list_of_DSO:
            p = URIRef(uri +extra)
            for s, p, o in g.triples((None, RDF.type, p)):
                spl = s.split("#")
                uri = spl[len(spl) - 2].split("/")
                out_list.append(spl[len(spl) - 1])
                #new code
                out_list.append(extra)
    #return tuple((str(keywordspl[len(keywordspl)-1]+" : "+n), str(keywordspl[len(keywordspl)-1]+" : "+n) ) for n in (out_list))
    return tuple((str(keywordspl[len(keywordspl)-1]+" : "+out_list[n+1]+" : "+out_list[n]), str(keywordspl[len(keywordspl)-1]+" : "+out_list[n+1]+" : "+out_list[n]) ) for n in range(0, len(out_list), 2))

# A list with the values and the file that is the instance
out_list = []
# A dict with all the info of classes, subclasses and instances
info_dict = {}

def get_file_and_instances(keyword):
    keywordspl = keyword.split("#")
    in_list = [keywordspl[len(keywordspl)-1]]
    with open('../../Ontologies/instances.txt') as f:
        for data in f:
            if (data.strip()).endswith(keyword):
                spliter_1 = data.split('$')
                spliter_2 = spliter_1[0].split("#")
                in_list.append(spliter_2[len(spliter_2) - 1])
    for extra in in_list:
        for uri in list_of_DSO:
            per = URIRef(uri +extra)
            for s, p, o in g.triples((None, RDF.type, per)):
                spl = s.split("#")
                uri = spl[len(spl) - 2].split("/")
                out_list.append(keywordspl[len(keywordspl)-1]+" : "+extra+" : " +spl[len(spl) - 1])
                out_list.append(str(spl[len(spl) - 2]))
    #return out_list#tuple((out_list[i+1], out_list[i]) for i in range(0, (len(out_list) - 1), 2) )

#Instances and Comments
def get_dmo_instance_and_comment(keyword):
    dmo_dic = {}
    dic_list = []
    mid_list = []
    out_list_com = []
    keywordspl = keyword.split("#")
    in_list = [keywordspl[len(keywordspl)-1]]
    with open('../../Ontologies/instances.txt') as f:
        for data in f:
            if (data.strip()).endswith(keyword):
                spliter_1 = data.split('$')
                spliter_2 = spliter_1[0].split("#")
                in_list.append(spliter_2[len(spliter_2) - 1])
    for extra in in_list:
        for uri in list_of_DSO:
            per = URIRef(uri +extra)
            for s, p, o in g.triples((None, RDF.type, per)):
                spl = s.split("#")
                uri = spl[len(spl) - 2].split("/")
                mid_list.append(extra)
                mid_list.append(spl[len(spl) - 1])
                dmo_dic = {'Class': extra, 'instance':spl[len(spl) - 1]}
                dic_list.append(dmo_dic)
    #need to find if instances have comment with their descreption!!!!!
    #for now it returns only the instances
    for extra in mid_list:
        for uri in list_of_DSO:
            per = URIRef(uri +extra)
            for s, p, o in g.triples((per, RDFS.comment, None)):
                spl = s.split("#")
                uri = spl[len(spl) - 2].split("/")
                out_list_com.append(str(extra))
                out_list_com.append((str(o).replace("\r","")).replace("\n",""))
    return dic_list



#Classes and Comments
def get_dmo_classes_and_comment(keyword):
    dmo_dic = {}
    dic_list = []
    dmo_dic_in = {}
    dic_list_in = []
    dmo_dic_backup = {}
    dic_list_backup = []
    out_list_instance = []
    out_list_com = []
    keywordspl = keyword.split("#")
    section = keywordspl[len(keywordspl)-1]
    in_list = [section]
    for extra in in_list:
        for uri in list_of_DSO:
            per = URIRef(uri +extra)
            for s, p, o in g.triples((None, RDFS.subClassOf, per)): #subClassOf
                spl = s.split("#")
                out_list_instance.append(spl[len(spl) - 1])
                dmo_dic_backup = {"Class": str(spl[len(spl) - 1]), "Comment":'', 'Subclass': '', 'Instance_of_Class':''}
                dic_list_backup.append(dmo_dic_backup)
    for extra in in_list:
        for uri in list_of_DSO:
            per = URIRef(uri +extra)
            for s, p, o in g.triples((None, RDF.type, per)):
                spl = s.split("#")
                uri = spl[len(spl) - 2].split("/")
                find_comment_gen_instance = ""
                for urired2 in list_of_DSO:
                    pop = URIRef(urired2 + spl[len(spl) - 1])
                    for q1, w1, m1 in g.triples((pop, RDFS.comment, None)):
                        find_comment_gen_instance = (str(m1).replace("\r","")).replace("\n","")
                dmo_dic_in = {'GeneralInstances': spl[len(spl) - 1], "Comment": find_comment_gen_instance}
                dic_list_in.append(dmo_dic_in)
    for comment in out_list_instance:
        instance_list = []
        instance_dict = {}
        for uri in list_of_DSO:
            per = URIRef(uri +comment)
            for s2, p2, o2 in g.triples((None, RDF.type, per)):
                spl = s2.split("#")
                find_comment_main_instance = ""
                for urired2 in list_of_DSO:
                    pop = URIRef(urired2 + spl[len(spl) - 1])
                    for q1, w1, m1 in g.triples((pop, RDFS.comment, None)):
                        find_comment_main_instance = (str(m1).replace("\r","")).replace("\n","")
                instance_dict = {"Instance": spl[len(spl) - 1], "Comment": find_comment_main_instance}
                instance_list.append(instance_dict)
        name_class = ""
        comment_class = ""
        for uri in list_of_DSO:
            per = URIRef(uri +comment)
            for s, p, o in g.triples((per, RDFS.comment, None)):
                out_list_com.append(str(comment))
                name_class = str(comment)
                out_list_com.append((str(o).replace("\r","")).replace("\n",""))
                comment_class = (str(o).replace("\r","")).replace("\n","")
                suclass_dict = {}
                subclass_list = []
                sub_ins_dict = {}
                for uri in list_of_DSO:
                    subclas_name = ""
                    per2 = URIRef(uri +comment)
                    for s1, p1, o1 in g.triples((None, RDFS.subClassOf, per2)):
                        spl1 = s1.split("#")
                        #subclass_list.append(spl1[len(spl1) - 1])
                        subclas_name = spl1[len(spl1) - 1]
                        kop = URIRef(uri + spl1[len(spl1) - 1])
                        find_comment = ""
                        find_comment_instance = ""
                        for q, w, m in g.triples((kop, RDFS.comment, None)):
                            find_comment = (str(m).replace("\r","")).replace("\n","")
                        sub_ins = []
                        for urired in list_of_DSO:
                            per3 = URIRef(urired + spl1[len(spl1) - 1])
                            for s2, p2, o2 in g.triples((None, RDF.type, per3)):
                                spl2 = s2.split("#")
                                for urired2 in list_of_DSO:
                                    kop2 = URIRef(urired2 + spl2[len(spl2) - 1])
                                    for q1, w1, m1 in g.triples((kop2, RDFS.comment, None)):
                                        find_comment_instance = (str(m1).replace("\r","")).replace("\n","")
                                sub_ins_dict = {"Instance": spl2[len(spl2) - 1], "Comment": find_comment_instance}
                                sub_ins.append(sub_ins_dict)
                        suclass_dict = {'SubClass_name': subclas_name, 'SubclassComment':find_comment, 'InstanceOfSubclass': sub_ins}
                        subclass_list.append(suclass_dict)
                dmo_dic = {"Class": name_class, "Comment":comment_class, 'Subclass': subclass_list, 'Instance_of_Class':instance_list}
                dic_list.append(dmo_dic)
    if out_list_com:
        Dictionary_Data = { "Name":section, "TheClasses" : dic_list, "GeneralInstances": dic_list_in}
        Dictionary_Data_list.append(Dictionary_Data)
        return dic_list
    else:
        if dic_list_backup:
            Dictionary_Data = { "Name":section, "TheClasses" : dic_list_backup, "GeneralInstances": dic_list_in}
            Dictionary_Data_list.append(Dictionary_Data)
            return dic_list_backup
        else:
            dmo_dic_backup = {"Class": " ", "Comment":" "}
            dic_list_backup.append(dmo_dic_backup)
            Dictionary_Data = { "Name":section, "TheClasses" : dic_list_backup, "GeneralInstances": dic_list_in}
            Dictionary_Data_list.append(Dictionary_Data)
            return dic_list_backup

#Classes of classes and Comments
def get_dmo_classes_of_classes_and_comment(keyword):
    dmo_dic = {}
    dic_list = []
    out_list_instance = []
    out_list_com = []
    mid_list = []
    find_comment = False
    keywordspl = keyword.split("#")
    in_list = [keywordspl[len(keywordspl)-1]]
    for extra in in_list:
        for uri in list_of_DSO:
            per = URIRef(uri +extra)
            for s, p, o in g.triples((None, RDFS.subClassOf, per)): #subClassOf
                spl = s.split("#")
                out_list_instance.append(spl[len(spl) - 1])
    for comment in out_list_instance:
        for uri in list_of_DSO:
            per = URIRef(uri +comment)
            for s, p, o in g.triples((None, RDFS.subClassOf, per)):
                spl = s.split("#")
                out_list_com.append(str(comment))
                out_list_com.append(spl[len(spl) - 1])
                kop = URIRef(uri + spl[len(spl) - 1])
                find_comment = ""
                for q, w, m in g.triples((kop, RDFS.comment, None)):
                    out_list_com.append((str(m).replace("\r","")).replace("\n",""))
                    find_comment = (str(m).replace("\r","")).replace("\n","")
                    dmo_dic = {"Class": str(comment),'Subclass': spl[len(spl) - 1], "SubclassComment":find_comment}
                    dic_list.append(dmo_dic)
    return(dic_list)


'''Get Instaces - return list'''
def get_instances_list(keyword):
    findsubclass()
    an_list=[]
    with open(subClass_instances) as f:
        for data in f:
            if (data.strip()).endswith(keyword):
                spliter_1 = data.split('$')
                spliter_2 = spliter_1[0].split("#")
                an_list.append(spliter_2[len(spliter_2) - 1])
    return an_list




'''Find Boilerplate subject of each main - return list'''
def get_subjects(bnodes_uriref):
    setOfElems = set()
    duplicate_uri = []
    bnodes = []
    rdf_syntax = 'http://www.w3.org/1999/02/22-rdf-syntax-ns#nil'

    for elem in range (len(bnodes_uriref)):
        if not bnodes_uriref[elem] in setOfElems:
            setOfElems.add(bnodes_uriref[elem])  
        else:
            duplicate_uri.append(bnodes_uriref[elem])
        if   rdf_syntax == str(bnodes_uriref[elem]) :
            bnodes = bnodes_uriref[:elem] 

    try:
        duplicate_uri.remove(URIRef(rdf_syntax)) 
    except:
        pass
    
    subject_list = []
    for i in duplicate_uri:
        if i in bnodes:
            spliter = str(i).split("#")
            subject_list.append(str(spliter[1]))
    return(subject_list)


'''Find Boilerplate classes between subject and verb - return list'''
def get_related_to_subject(bnodes_uriref):
    related_to_subject_list = []
    bnodes_uriref = [str(i) for i in bnodes_uriref]
    for rel_to_sub in bnodes_uriref:
        if "isRelatedToSubject" in rel_to_sub:
            tmp = rel_to_sub.split("isRelatedToSubject")
            if tmp[1] != '':
                related_to_subject_list.append(tmp[1])
    return(related_to_subject_list)


'''Find Boilerplate Verb - return list'''
def get_verb(bnodes_uriref):
    verb_list = []
    out_list =[]
    bnodes_uriref = [str(i) for i in bnodes_uriref]
    for rel_to_sub in bnodes_uriref:
        if "LO" in rel_to_sub:
            tmp = rel_to_sub.split("#")
            if tmp[1] != '':
                verb_list.append(tmp[1])
    for extra in verb_list:
        per = URIRef("http://delab.csd.auth.gr/ontologies/2018/LO#" +extra)
        for s, p, o in g.triples((None, RDF.type, per)):
            spl = s.split("#")
            out_list.append(str(spl[1]))
    return(out_list)


'''Check if Boilerplate has quantifier - return list'''
def check_quantifier(bnodes_uriref):
    bnodes_uriref = [str(i) for i in bnodes_uriref]
    quantity = [(rel_to_sub) for rel_to_sub in bnodes_uriref if "isRelatedToQuantity" in rel_to_sub]
    uom = [(rel_to_sub) for rel_to_sub in bnodes_uriref if "isRelatedtoUOM" in rel_to_sub]
    if quantity and uom:
        return True


'''Find Boilerplate Attribute - return list'''
def get_attribute(bnodes_uriref, subjects, related_subjects, verbs):
    bnodes = []
    attribute_list = []
    bnodes_uriref = [str(i) for i in bnodes_uriref]
    for attribute in bnodes_uriref:
        if "isRelatedToSubject" in attribute:
            pass
        elif "isRelatedTo" in attribute:
            tmp = attribute.split("#")
            if tmp[1] != '':
                tmp = tmp[1].split("isRelatedTo")
                attribute_list.append(tmp[1])
        #to be deleted in only exist isRelatedTo
        elif "isRelatedto" in attribute:
            tmp = attribute.split("#")
            if tmp[1] != '':
                tmp = tmp[1].split("isRelatedto")
                attribute_list.append(tmp[1])
    attribute_list = list(filter(("Action").__ne__, attribute_list))
    attribute_list = list(filter(("Attribute").__ne__, attribute_list))
    attribute_list = list(filter(("Quantity").__ne__, attribute_list))
    attribute_list = list(filter(("UOM").__ne__, attribute_list))
    #discuss with kostas if this needed
    attribute_list = list(filter(("TraversingConcept").__ne__, attribute_list))
    
    tmp_list = []
    for i in bnodes_uriref:
        if not "isRelatedTo" in i:
            if not "isRelatedto" in i:
                tmp = i.split("#")
                if(len(tmp) > 1):
                    if tmp[1] != '':
                        tmp_list.append(tmp[1])
    
    tmp_list = list(filter(("nil").__ne__, tmp_list))
    tmp_list = list(filter(("Restriction").__ne__, tmp_list))
    tmp_list = list(filter(("Class").__ne__, tmp_list))
    tmp_list = list(filter(("Action").__ne__, tmp_list))
    tmp_list = list(filter(("Quantity").__ne__, tmp_list))
    tmp_list = list(filter(("UnitOfMeasurement").__ne__, tmp_list))
    for i in subjects:
        tmp_list = list(filter((i).__ne__, tmp_list))
    for i in related_subjects:
        tmp_list = list(filter((i).__ne__, tmp_list))
    for i in verbs:
        tmp_list = list(filter((i).__ne__, tmp_list))

    res = attribute_list + tmp_list
    res = list(dict.fromkeys(res))
    return(res)


'''Find Main syntax - return a dict with the syntax'''
def get_main_sytax_inference():
    get_main = get_instances_list("RBO#Main")
    main_dict = {}
    for main in get_main:
        bnodes = []
        p = URIRef("http://delab.csd.auth.gr/ontologies/2018/RBO#" + main)
        for s, p, o in g.triples((p, None, None)):
            if isinstance(o, BNode):
                bnodes.append(o)
        bnodes.sort()

        for bn in bnodes:
            for objects in g.objects(subject=BNode(bn)):
                if isinstance(objects, BNode):
                    bnodes.append(objects)
                
        bnodes.sort()

        bnodes_uriref = []

        for bn in bnodes:
            for objects in g.objects(subject=BNode(bn)):
                if isinstance(objects, URIRef):
                    bnodes_uriref.append(objects)
        
        main_dict[main] = {}
        main_dict[main]["Subject"] = get_subjects(bnodes_uriref)
        main_dict[main]["Related_to_Subject"] = get_related_to_subject(bnodes_uriref)
        main_dict[main]["Verbs"] = get_verb(bnodes_uriref)
        main_dict[main]["Quantifier"] = check_quantifier(bnodes_uriref)
        main_dict[main]["Attributes"] = get_attribute(bnodes_uriref, main_dict[main]["Subject"], main_dict[main]["Related_to_Subject"], main_dict[main]["Verbs"])


    return main_dict


'''Find Main syntax - return a dict with the syntax'''
def get_main_sytax():
    get_main = get_instances_list("RBO#Main")
    main_dict = {}
    main_dict_list = []
    for main in get_main:
        bnodes = []
        p = URIRef("http://delab.csd.auth.gr/ontologies/2018/RBO#" + main)
        for s, p, o in g.triples((p, None, None)):
            if isinstance(o, BNode):
                bnodes.append(o)
        bnodes.sort()

        for bn in bnodes:
            for objects in g.objects(subject=BNode(bn)):
                if isinstance(objects, BNode):
                    bnodes.append(objects)
                
        bnodes.sort()

        bnodes_uriref = []

        for bn in bnodes:
            for objects in g.objects(subject=BNode(bn)):
                if isinstance(objects, URIRef):
                    bnodes_uriref.append(objects)
        
        main_dict[main] = {}
        main_dict[main]["Id"] = main
        main_dict[main]["Subject"] = get_subjects(bnodes_uriref)
        main_dict[main]["Related_to_Subject"] = get_related_to_subject(bnodes_uriref)
        main_dict[main]["Verbs"] = get_verb(bnodes_uriref)
        main_dict[main]["Quantifier"] = check_quantifier(bnodes_uriref)
        main_dict[main]["Attributes"] = get_attribute(bnodes_uriref, main_dict[main]["Subject"], main_dict[main]["Related_to_Subject"], main_dict[main]["Verbs"])
        main_dict_list.append(main_dict[main])

    return main_dict_list


'''Find Prefix syntax - return a dict with the syntax'''
def get_prefix_syntax():
    prefix_dict={}
    prefix_list = []
    get_prefix = get_instances_list("RBO#Prefix")
    for prefix in get_prefix:
        prefix_list.extend(get_instances_list(prefix))
    for prefix in prefix_list:
        prefix_dict[prefix] = {}
        prefix_dict[prefix]["Verbs"] = []
        bnodes_uriref = find_triples(prefix)
        subclass_data = []
        for per in bnodes_uriref:
            tmp = get_instances_list(str(per))
            for i in tmp:
                subclass_data.append(i)
        for pre in subclass_data:
            tmp_list = []
            tmp_list2 = find_triples(pre)
            tmp_list2 = [str(i) for i in tmp_list2]
            for i in tmp_list2:
                tmp = i.split("#")
                tmp_list.append(tmp[1])
            tmp_list = list(filter(("nil").__ne__, tmp_list))
            tmp_list = list(filter(("Restriction").__ne__, tmp_list))
            tmp_list = list(filter(("Class").__ne__, tmp_list))
            tmp_list = list(filter(("Action").__ne__, tmp_list))
            tmp_list = list(filter(("Quantity").__ne__, tmp_list))
            tmp_list = list(filter(("UnitOfMeasurement").__ne__, tmp_list))
            isrelated = []
            sub = []
            for i in tmp_list:
                if "isRelatedTo" in i:
                    isrelated.append(i)
                else:
                    sub.append(i)
            for i in sub:
                for j in isrelated:
                    if i in j:
                        prefix_dict[prefix]["Attribute"] = i
                        sub.remove(i)
            if tmp_list2:
                ver = get_verb(tmp_list2)
                prefix_dict[prefix]["Verbs"].append(ver)
                #for i in ver:
                #    sub.remove(i)
            prefix_dict[prefix]["Suject"] = sub
    return prefix_dict        


'''Find the triples of the prefix - return list.type(URIRef)'''
def find_triples(prefix):
    bnodes = []
    URIRef_list = []
    per = URIRef("http://delab.csd.auth.gr/ontologies/2018/RBO#" + prefix)
    for s, p, o in g.triples((per, None, None)):
        if isinstance(o, BNode):
            bnodes.append(o)
    bnodes.sort()

    for bn in bnodes:
        for objects in g.objects(subject=BNode(bn)):
            if isinstance(objects, BNode):
                bnodes.append(objects)     
    bnodes.sort()
    bnodes_uriref = []

    for bn in bnodes:
        for objects in g.objects(subject=BNode(bn)):
            if isinstance(objects, URIRef):
                bnodes_uriref.append(objects)
    return bnodes_uriref